Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs	(revision 13469)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs	(revision 13470)
@@ -20,8 +20,11 @@
 #endregion
 
+using System;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -37,4 +40,25 @@
     public AnalyticalProbabilisticTravelingSalesmanProblem() {
       Operators.Add(new BestPTSPSolutionAnalyzer());
+
+      Operators.Add(new PTSPAnalyticalInversionMoveEvaluator());
+      Operators.Add(new PTSPAnalyticalInsertionMoveEvaluator());
+      Operators.Add(new PTSPAnalyticalInversionLocalImprovement());
+      Operators.Add(new PTSPAnalyticalInsertionLocalImprovement());
+      Operators.Add(new PTSPAnalyticalTwoPointFiveLocalImprovement());
+
+      Operators.Add(new ExhaustiveTwoPointFiveMoveGenerator());
+      Operators.Add(new StochasticTwoPointFiveMultiMoveGenerator());
+      Operators.Add(new StochasticTwoPointFiveSingleMoveGenerator());
+      Operators.Add(new TwoPointFiveMoveMaker());
+      Operators.Add(new PTSPAnalyticalTwoPointFiveMoveEvaluator());
+
+      Operators.RemoveAll(x => x is SingleObjectiveMoveGenerator);
+      Operators.RemoveAll(x => x is SingleObjectiveMoveMaker);
+      Operators.RemoveAll(x => x is SingleObjectiveMoveEvaluator);
+
+      Encoding.ConfigureOperators(Operators.OfType<IOperator>());
+      foreach (var twopointfiveMoveOperator in Operators.OfType<ITwoPointFiveMoveOperator>()) {
+        twopointfiveMoveOperator.TwoPointFiveMoveParameter.ActualName = "Permutation.TwoPointFiveMove";
+      }
     }
 
@@ -44,26 +68,32 @@
 
     public override double Evaluate(Permutation tour, IRandom random) {
+      // abeham: Cache in local variable for performance reasons
+      var distanceMatrix = DistanceMatrix;
+      return Evaluate(tour, (a, b) => distanceMatrix[a, b], Probabilities);
+    }
+
+    public static double Evaluate(Permutation tour, Func<int, int, double> distance, DoubleArray probabilities) {
       // Analytical evaluation
-      double firstSum = 0;
-      for (int i = 0; i < tour.Length - 1; i++) {
-        for (int j = i + 1; j < tour.Length - 1; j++) {
-          double sum1 = DistanceMatrix[tour[i], tour[j]] * Probabilities[tour[i]] * Probabilities[tour[j]];
-          for (int k = i + 1; k < j; k++) {
-            sum1 = sum1 * (1 - Probabilities[tour[k]]);
+      var firstSum = 0.0;
+      for (var i = 0; i < tour.Length - 1; i++) {
+        for (var j = i + 1; j < tour.Length; j++) {
+          var prod1 = distance(tour[i], tour[j]) * probabilities[tour[i]] * probabilities[tour[j]];
+          for (var k = i + 1; k < j; k++) {
+            prod1 = prod1 * (1 - probabilities[tour[k]]);
           }
-          firstSum += sum1;
+          firstSum += prod1;
         }
       }
-      double secondSum = 0;
-      for (int j = 0; j < tour.Length - 1; j++) {
-        for (int i = 0; i < j; i++) {
-          double sum2 = DistanceMatrix[tour[j], tour[i]] * Probabilities[tour[i]] * Probabilities[tour[j]];
-          for (int k = j + 1; k < tour.Length - 1; k++) {
-            sum2 = sum2 * (1 - Probabilities[tour[k]]);
+      var secondSum = 0.0;
+      for (var j = 0; j < tour.Length; j++) {
+        for (var i = 0; i < j; i++) {
+          var prod2 = distance(tour[j], tour[i]) * probabilities[tour[i]] * probabilities[tour[j]];
+          for (var k = j + 1; k < tour.Length; k++) {
+            prod2 = prod2 * (1 - probabilities[tour[k]]);
           }
-          for (int k = 1; k < i; k++) {
-            sum2 = sum2 * (1 - Probabilities[tour[k]]);
+          for (var k = 0; k < i; k++) {
+            prod2 = prod2 * (1 - probabilities[tour[k]]);
           }
-          secondSum += sum2;
+          secondSum += prod2;
         }
       }
@@ -72,29 +102,5 @@
 
     public static double Evaluate(Permutation tour, DistanceMatrix distanceMatrix, DoubleArray probabilities) {
-      // Analytical evaluation
-      var firstSum = 0.0;
-      for (var i = 0; i < tour.Length; i++) {
-        for (var j = i + 1; j < tour.Length; j++) {
-          var sum1 = distanceMatrix[tour[i], tour[j]] * probabilities[tour[i]] * probabilities[tour[j]];
-          for (var k = i + 1; k < j; k++) {
-            sum1 = sum1 * (1 - probabilities[tour[k]]);
-          }
-          firstSum += sum1;
-        }
-      }
-      var secondSum = 0.0;
-      for (var j = 0; j < tour.Length; j++) {
-        for (var i = 0; i < j; i++) {
-          var sum2 = distanceMatrix[tour[j], tour[i]] * probabilities[tour[i]] * probabilities[tour[j]];
-          for (var k = j + 1; k < tour.Length; k++) {
-            sum2 = sum2 * (1 - probabilities[tour[k]]);
-          }
-          for (var k = 0; k < i; k++) {
-            sum2 = sum2 * (1 - probabilities[tour[k]]);
-          }
-          secondSum += sum2;
-        }
-      }
-      return firstSum + secondSum;
+      return Evaluate(tour, (a, b) => distanceMatrix[a, b], probabilities);
     }
   }
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs	(revision 13469)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs	(revision 13470)
@@ -26,4 +26,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -72,6 +73,7 @@
       Operators.Add(new PTSPEstimatedInversionMoveEvaluator());
       Operators.Add(new PTSPEstimatedInsertionMoveEvaluator());
-      Operators.Add(new PTSPExhaustiveInversionLocalImprovement());
-      Operators.Add(new PTSPExhaustiveInsertionLocalImprovement());
+      Operators.Add(new PTSPEstimatedInversionLocalImprovement());
+      Operators.Add(new PTSPEstimatedInsertionLocalImprovement());
+      Operators.Add(new PTSPEstimatedTwoPointFiveLocalImprovement());
 
       Operators.Add(new ExhaustiveTwoPointFiveMoveGenerator());
@@ -79,5 +81,9 @@
       Operators.Add(new StochasticTwoPointFiveSingleMoveGenerator());
       Operators.Add(new TwoPointFiveMoveMaker());
-      Operators.Add(new PTSPTwoPointFiveMoveEvaluator());
+      Operators.Add(new PTSPEstimatedTwoPointFiveMoveEvaluator());
+
+      Operators.RemoveAll(x => x is SingleObjectiveMoveGenerator);
+      Operators.RemoveAll(x => x is SingleObjectiveMoveMaker);
+      Operators.RemoveAll(x => x is SingleObjectiveMoveEvaluator);
 
       Encoding.ConfigureOperators(Operators.OfType<IOperator>());
@@ -86,4 +92,5 @@
       }
 
+      UpdateRealizations();
       RegisterEventHandlers();
     }
@@ -107,12 +114,20 @@
 
     public override double Evaluate(Permutation tour, IRandom random) {
-      // Estimation-based evaluation
+      // abeham: Cache parameters in local variables for performance reasons
+      var realizations = Realizations;
+      var realizationsSize = RealizationsSize;
+      var useDistanceMatrix = UseDistanceMatrix;
+      var distanceMatrix = DistanceMatrix;
+      var distanceCalculator = DistanceCalculator;
+      var coordinates = Coordinates;
+
+      // Estimation-based evaluation, here without calculating variance for faster evaluation
       var estimatedSum = 0.0;
-      for (var i = 0; i < Realizations.Count; i++) {
+      for (var i = 0; i < realizations.Count; i++) {
         int singleRealization = -1, firstNode = -1;
-        for (var j = 0; j < Realizations[i].Length; j++) {
-          if (Realizations[i][tour[j]]) {
+        for (var j = 0; j < realizations[i].Length; j++) {
+          if (realizations[i][tour[j]]) {
             if (singleRealization != -1) {
-              estimatedSum += GetDistance(singleRealization, tour[j]);
+              estimatedSum += useDistanceMatrix ? distanceMatrix[singleRealization, tour[j]] : distanceCalculator.Calculate(singleRealization, tour[j], coordinates);
             } else {
               firstNode = tour[j];
@@ -122,8 +137,8 @@
         }
         if (singleRealization != -1) {
-          estimatedSum += GetDistance(singleRealization, firstNode);
-        }
-      }
-      return estimatedSum / RealizationsSize;
+          estimatedSum += useDistanceMatrix ? distanceMatrix[singleRealization, firstNode] : distanceCalculator.Calculate(singleRealization, firstNode, coordinates);
+        }
+      }
+      return estimatedSum / realizationsSize;
     }
 
@@ -134,6 +149,19 @@
     /// <param name="distanceMatrix">The distances between the cities.</param>
     /// <param name="realizations">A sample of realizations of the stochastic instance</param>
+    /// <param name="variance">The estimated variance will be returned in addition to the mean.</param>
     /// <returns>A vector with length two containing mean and variance.</returns>
-    public static double[] Evaluate(Permutation tour, DistanceMatrix distanceMatrix, ItemList<BoolArray> realizations) {
+    public static double Evaluate(Permutation tour, DistanceMatrix distanceMatrix, ItemList<BoolArray> realizations, out double variance) {
+      return Evaluate(tour, (a, b) => distanceMatrix[a, b], realizations, out variance);
+    }
+
+    /// <summary>
+    /// An evaluate method that can be used if mean as well as variance should be calculated
+    /// </summary>
+    /// <param name="tour">The tour between all cities.</param>
+    /// <param name="distance">A func that accepts the index of two cities and returns the distance as a double.</param>
+    /// <param name="realizations">A sample of realizations of the stochastic instance</param>
+    /// <param name="variance">The estimated variance will be returned in addition to the mean.</param>
+    /// <returns>A vector with length two containing mean and variance.</returns>
+    public static double Evaluate(Permutation tour, Func<int, int, double> distance, ItemList<BoolArray> realizations, out double variance) {
       // Estimation-based evaluation
       var estimatedSum = 0.0;
@@ -145,5 +173,5 @@
           if (realizations[i][tour[j]]) {
             if (singleRealization != -1) {
-              partialSums[i] += distanceMatrix[singleRealization, tour[j]];
+              partialSums[i] += distance(singleRealization, tour[j]);
             } else {
               firstNode = tour[j];
@@ -153,20 +181,24 @@
         }
         if (singleRealization != -1) {
-          partialSums[i] += distanceMatrix[singleRealization, firstNode];
+          partialSums[i] += distance(singleRealization, firstNode);
         }
         estimatedSum += partialSums[i];
       }
       var mean = estimatedSum / realizations.Count;
-      var variance = 0.0;
+      variance = 0.0;
       for (var i = 0; i < realizations.Count; i++) {
         variance += Math.Pow((partialSums[i] - mean), 2);
       }
       variance = variance / realizations.Count;
-      return new[] { mean, variance };
-    }
-
-    public double GetDistance(int from, int to) {
-      if (UseDistanceMatrix) return DistanceMatrix[from, to];
-      return DistanceCalculator.Calculate(from, to, Coordinates);
+      return mean;
+    }
+
+    public override void Load(PTSPData data) {
+      base.Load(data);
+      UpdateRealizations();
+
+      foreach (var op in Operators.OfType<IEstimatedPTSPOperator>()) {
+        op.RealizationsParameter.ActualName = RealizationsParameter.Name;
+      }
     }
 
@@ -177,5 +209,5 @@
         var newRealization = new BoolArray(Probabilities.Length);
         var countOnes = 0;
-        while (countOnes < 4) { // only generate realizations with at least 4 cities visited
+        do {
           countOnes = 0;
           for (var j = 0; j < Probabilities.Length; j++) {
@@ -183,17 +215,9 @@
             if (newRealization[j]) countOnes++;
           }
-        }
-        Realizations.Add(newRealization);
+          // only generate realizations with at least 4 cities visited
+        } while (countOnes < 4 && Probabilities.Length > 3);
+        realizations.Add(newRealization);
       }
       Realizations = realizations;
-    }
-
-    public override void Load(PTSPData data) {
-      base.Load(data);
-      UpdateRealizations();
-
-      foreach (var op in Operators.OfType<IEstimatedPTSPOperator>()) {
-        op.RealizationsParameter.ActualName = RealizationsParameter.Name;
-      }
     }
   }
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/HeuristicLab.Problems.PTSP-3.3.csproj
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/HeuristicLab.Problems.PTSP-3.3.csproj	(revision 13469)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/HeuristicLab.Problems.PTSP-3.3.csproj	(revision 13470)
@@ -36,4 +36,40 @@
   <PropertyGroup>
     <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
   </PropertyGroup>
   <ItemGroup>
@@ -123,13 +159,23 @@
     <Compile Include="DistanceMatrix.cs" />
     <Compile Include="EstimatedPTSP.cs" />
-    <Compile Include="Improvers\PTSPExhaustiveInsertionLocalImprovement.cs" />
-    <Compile Include="Improvers\PTSPExhaustiveInversionLocalImprovement.cs" />
+    <Compile Include="Improvers\PTSPAnalyticalInsertionLocalImprovement.cs" />
+    <Compile Include="Improvers\PTSPAnalyticalTwoPointFiveLocalImprovement.cs" />
+    <Compile Include="Improvers\PTSPEstimatedInsertionLocalImprovement.cs" />
+    <Compile Include="Improvers\PTSPAnalyticalInversionLocalImprovement.cs" />
+    <Compile Include="Improvers\PTSPEstimatedTwoPointFiveLocalImprovement.cs" />
+    <Compile Include="Improvers\PTSPEstimatedInversionLocalImprovement.cs" />
+    <Compile Include="Interfaces\IAnalyticalPTSPMoveEvaluator.cs" />
+    <Compile Include="Interfaces\IAnalyticalPTSPOperator.cs" />
     <Compile Include="Interfaces\IEstimatedPTSPOperator.cs" />
     <Compile Include="Interfaces\ITwoPointFiveMoveOperator.cs" />
     <Compile Include="Interfaces\IEstimatedPTSPMoveEvaluator.cs" />
+    <Compile Include="Moves\AnalyticalPTSPMoveEvaluator.cs" />
+    <Compile Include="Moves\OneShift\PTSPAnalyticalInsertionMoveEvaluator.cs" />
     <Compile Include="Moves\OneShift\PTSPEstimatedInsertionMoveEvaluator.cs" />
     <Compile Include="Moves\EstimatedPTSPMoveEvaluator.cs" />
+    <Compile Include="Moves\TwoOpt\PTSPAnalyticalInversionMoveEvaluator.cs" />
     <Compile Include="Moves\TwoOpt\PTSPEstimatedInversionMoveEvaluator.cs" />
-    <Compile Include="Moves\TwoPointFiveOpt\PTSPTwoPointFiveMoveEvaluator.cs" />
+    <Compile Include="Moves\TwoPointFiveOpt\PTSPAnalyticalTwoPointFiveMoveEvaluator.cs" />
+    <Compile Include="Moves\TwoPointFiveOpt\PTSPEstimatedTwoPointFiveMoveEvaluator.cs" />
     <Compile Include="Moves\TwoPointFiveOpt\ExhaustiveTwoPointFiveMoveGenerator.cs" />
     <Compile Include="Moves\TwoPointFiveOpt\StochasticTwoPointFiveMultiMoveGenerator.cs" />
@@ -158,7 +204,12 @@
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
-set Outdir=$(Outdir)
 
 call PreBuildEvent.cmd</PreBuildEvent>
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+      export ProjectDir=$(ProjectDir)
+      export SolutionDir=$(SolutionDir)
+
+      $SolutionDir/PreBuildEvent.sh
+    </PreBuildEvent>
   </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInsertionLocalImprovement.cs
===================================================================
--- /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInsertionLocalImprovement.cs	(revision 13470)
+++ /branches/PTSP/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInsertionLocalImprovement.cs	(revision 13470)
@@ -0,0 +1,145 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.PTSP {
+  /// <summary>
+  /// An operator that improves probabilistic traveling salesman solutions.
+  /// </summary>
+  /// <remarks>
+  /// The operator tries to improve the probabilistic traveling salesman solution by inserting a city in the tour between two other cities for a certain number of times.
+  /// </remarks>
+  [Item("PTSP Analytical Insertion Local Improvement", "An operator that improves probabilistic traveling salesman solutions. The operator tries to improve the probabilistic traveling salesman solution by swapping two randomly chosen edges for a certain number of times.")]
+  [StorableClass]
+  public sealed class PTSPAnalyticalInsertionLocalImprovement : SingleSuccessorOperator, IAnalyticalPTSPOperator, ILocalImprovementOperator {
+
+    public ILookupParameter<IntValue> LocalIterationsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["LocalIterations"]; }
+    }
+
+    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
+    }
+
+    public ILookupParameter<IntValue> EvaluatedSolutionsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
+    }
+
+    public ILookupParameter<ResultCollection> ResultsParameter {
+      get { return (ILookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+
+    public ILookupParameter<Permutation> PermutationParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["Permutation"]; }
+    }
+
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+
+    public ILookupParameter<BoolValue> MaximizationParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
+
+    public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
+      get { return (ILookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
+    }
+
+    public ILookupParameter<DoubleArray> ProbabilitiesParameter {
+      get { return (ILookupParameter<DoubleArray>)Parameters["Probabilities"]; }
+    }
+
+    [StorableConstructor]
+    private PTSPAnalyticalInsertionLocalImprovement(bool deserializing) : base(deserializing) { }
+    private PTSPAnalyticalInsertionLocalImprovement(PTSPAnalyticalInsertionLocalImprovement original, Cloner cloner) : base(original, cloner) { }
+    public PTSPAnalyticalInsertionLocalImprovement()
+      : base() {
+      Parameters.Add(new LookupParameter<Permutation>("Permutation", "The solution as permutation."));
+      Parameters.Add(new LookupParameter<IntValue>("LocalIterations", "The number of iterations that have already been performed."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations", "The maximum amount of iterations that should be performed (note that this operator will abort earlier when a local optimum is reached).", new IntValue(10000)));
+      Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The amount of evaluated solutions (here a move is counted only as 4/n evaluated solutions with n being the length of the permutation)."));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results", "The collection where to store results."));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value of the assignment."));
+      Parameters.Add(new LookupParameter<BoolValue>("Maximization", "True if the problem should be maximized or minimized."));
+      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the cities."));
+      Parameters.Add(new LookupParameter<DoubleArray>("Probabilities", "The list of probabilities of the cities to appear."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PTSPAnalyticalInsertionLocalImprovement(this, cloner);
+    }
+
+    public static void Improve(Permutation assignment, DoubleMatrix distances, DoubleValue quality, IntValue localIterations, IntValue evaluatedSolutions, bool maximization, int maxIterations, DoubleArray probabilities, CancellationToken cancellation) {
+      var distanceM = (DistanceMatrix)distances;
+      Func<int, int, double> distance = (a, b) => distanceM[a, b];
+      for (var i = localIterations.Value; i < maxIterations; i++) {
+        TranslocationMove bestMove = null;
+        var bestQuality = quality.Value; // we have to make an improvement, so current quality is the baseline
+        var evaluations = 0.0;
+        foreach (var move in ExhaustiveInsertionMoveGenerator.Generate(assignment)) {
+          var moveQuality = PTSPAnalyticalInsertionMoveEvaluator.EvaluateMove(assignment, move, distance, probabilities);
+          evaluations++;
+          if (maximization && moveQuality > bestQuality
+            || !maximization && moveQuality < bestQuality) {
+            bestQuality = moveQuality;
+            bestMove = move;
+          }
+        }
+        evaluatedSolutions.Value += (int)Math.Ceiling(evaluations);
+        if (bestMove == null) break;
+        TranslocationManipulator.Apply(assignment, bestMove.Index1, bestMove.Index2, bestMove.Index3);
+        quality.Value = bestQuality;
+        localIterations.Value++;
+        cancellation.ThrowIfCancellationRequested();
+      }
+    }
+
+    public override IOperation Apply() {
+      var maxIterations = MaximumIterationsParameter.ActualValue.Value;
+      var assignment = PermutationParameter.ActualValue;
+      var maximization = MaximizationParameter.ActualValue.Value;
+      var distances = DistanceMatrixParameter.ActualValue;
+      var quality = QualityParameter.ActualValue;
+      var localIterations = LocalIterationsParameter.ActualValue;
+      var evaluations = EvaluatedSolutionsParameter.ActualValue;
+      var probabilities = ProbabilitiesParameter.ActualValue;
+      if (localIterations == null) {
+        localIterations = new IntValue(0);
+        LocalIterationsParameter.ActualValue = localIterations;
+      }
+
+      Improve(assignment, distances, quality, localIterations, evaluations, maximization, maxIterations, probabilities, CancellationToken);
+
+      localIterations.Value = 0;
+      return base.Apply();
+    }
+  }
+}
